/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "../src/thunk_gen.y"

/*
 * function prototype parser
 * Author: Stas Sergeev
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <assert.h>

#define YYDEBUG 1

static int tg_abi = 3;

static void yyerror(const char* s);
int yylex(void);

static int thunk_type;
static int ptr_size;
static int align;

static int arg_num;
static int arg_offs;
static int arg_size;
static int al_arg_size;
static int arr_sz;
static int is_ptr;
static int is_arr;
static int is_rptr;
static int is_far;
static int is_rfar;
static int is_ffar;
static int is_cbk;
static int is_void;
static int is_rvoid;
static int is_const;
static int is_out;
static int is_pas;
static int is_init;
static int is_noret;
static int ref_inc;
static int ref_mult;
static int rlen;
static char abuf[1024];
static char atype[256];
static char atype2[256];
static char atype3[256];
static char rtbuf[256];
/* conversion types for flat pointers */
enum { CVTYPE_OTHER, CVTYPE_VOID, CVTYPE_CHAR, CVTYPE_ARR, CVTYPE_CHAR_ARR };
static int cvtype;


static void beg_arg(void)
{
    is_far = 0;
    is_ptr = 0;
    is_arr = 0;
    is_cbk = 0;
    is_void = 0;
    is_const = 0;
    is_out = 0;
    cvtype = CVTYPE_OTHER;
    arr_sz = 0;
    atype[0] = 0;
    atype2[0] = 0;
    atype3[0] = 0;
    arg_size = 0;
    ref_inc = 0;
    ref_mult = 0;
}

static void init_line(void)
{
    is_init = 0;
    is_pas = 0;
    is_rvoid = 0;
    is_rptr = 0;
    is_rfar = 0;
    is_ffar = 0;
    is_noret = 0;
    rlen = 0;
    beg_arg();
}

static const char *get_pref(void)
{
    if (is_const)
	return "C";
    if (is_out)
	return "O";
    return "";
}

static void do_start_arg(int anum)
{
    if (thunk_type == 1 || thunk_type == 2)
	strcat(abuf, "_");
    if (is_ptr) {
	if (is_far) {
	    switch (anum) {
	    case 0:
		strcat(abuf, "_ARG_PTR_FAR(");
		break;
	    case 1:
		strcat(abuf, "_ARG_PTR_FAR_A(");
		break;
	    case 2:
		strcat(abuf, "_CNV_PTR_FAR, _L_NONE");
		break;
	    }
	} else {
	    switch (anum) {
	    case 0:
		strcat(abuf, "_ARG_PTR(");
		break;
	    case 1:
		strcat(abuf, "_ARG_PTR_A(");
		break;
	    case 2:
		/* flat pointers need conversion to far */
		switch (cvtype) {
		case CVTYPE_VOID:
		    if (ref_inc)
			sprintf(abuf + strlen(abuf), "_CNV_PTR_%sVOID, _L_REF(%i, %i)",
				get_pref(), arg_num + 1 + ref_inc, ref_mult);
		    else
			sprintf(abuf + strlen(abuf), "_CNV_PTR_%sPVOID, _L_NONE",
				get_pref());
		    break;
		case CVTYPE_CHAR:
		    if (is_const)
			strcat(abuf, "_CNV_PTR_CCHAR, _L_NONE");
		    else
			strcat(abuf, "_CNV_PTR_CHAR, _L_UNIMP");
		    break;
		case CVTYPE_CHAR_ARR:
		    if (is_const) {
			if (arr_sz == -1)  // main() template
			    strcat(abuf, "_CNV_PTR_CCHAR_ARR, _L_UNIMP"); // FIXME!
			else
			    sprintf(abuf + strlen(abuf), "_CNV_PTR_CCHAR_ARR, "
				    "_L_IMM(%i, %i)", arg_num + 1, arr_sz);
		    } else
			strcat(abuf, "_CNV_PTR_CHAR_ARR, _L_UNIMP");
		    break;
		case CVTYPE_ARR:
		    sprintf(abuf + strlen(abuf), "_CNV_PTR_%sARR, _L_IMM(%i, %i)",
			    get_pref(), arg_num + 1, arr_sz);
		    break;
		case CVTYPE_OTHER:
		    sprintf(abuf + strlen(abuf), "_CNV_%sPTR, _L_SZ(%i)",
			    get_pref(), arg_num + 1);
		    break;
		}
		break;
	    }
	}
    } else if (is_cbk) {
	switch (anum) {
	case 0:
	    strcat(abuf, "_ARG_CBK(");
	    break;
	case 1:
	    strcat(abuf, "_ARG_CBK_A(");
	    break;
	case 2:
	    strcat(abuf, "_CNV_CBK, _L_NONE");
	    break;
	}
    } else if (is_arr) {
	switch (anum) {
	case 0:
	    strcat(abuf, "_ARG_ARR(");
	    break;
	case 1:
	    strcat(abuf, "_ARG_ARR_A(");
	    break;
	case 2:
	    switch (cvtype) {
	    case CVTYPE_CHAR_ARR:
		if (is_const) {
		    if (arr_sz == -1)
			strcat(abuf, "_CNV_CCHAR_ARR, _L_UNIMP"); // FIXME!
		    else
			sprintf(abuf + strlen(abuf), "_CNV_CCHAR_ARR, "
				    "_L_IMM(%i, %i)", arg_num + 1, arr_sz);
		} else
		    sprintf(abuf + strlen(abuf), "_CNV_CHAR_%sARR, "
				    "_L_IMM(%i, %i)",
				    get_pref(), arg_num + 1, arr_sz);
		break;
	    case CVTYPE_ARR:
		sprintf(abuf + strlen(abuf), "_CNV_%sARR, _L_IMM(%i, %i)",
			    get_pref(), arg_num + 1, arr_sz);
		break;
	    case CVTYPE_OTHER:
		sprintf(abuf + strlen(abuf), "_CNV_%sPTR, _L_SZ(%i)",
			    get_pref(), arg_num + 1);
		break;
	    }
	}
    } else {
	switch (anum) {
	case 0:
	    strcat(abuf, "_ARG(");
	    break;
	case 1:
	    strcat(abuf, "_ARG_A(");
	    break;
	case 2:
	    strcat(abuf, "_CNV_SIMPLE, _L_NONE");
	    break;
	}
    }
}

static void fin_arg(int last)
{
    int real_arg_size;
    if (!atype[0])
	return;
    if (!is_ptr && is_void)
	return;
    do_start_arg(0);
    switch (thunk_type) {
    case 0:
	sprintf(abuf + strlen(abuf), "%i, %s%s%s, _SP)", arg_offs,
		is_const ? "const " : "", atype, is_arr ? " *" : "");
	break;
    case 1:
    case 2:
	if (is_const)
	    strcat(abuf, "const ");
	sprintf(abuf + strlen(abuf), "%s)", atype);
	strcat(abuf, ", ");
	if (is_arr) {
	    if (arr_sz != -1)
		sprintf(abuf + strlen(abuf), "[%i], ", arr_sz);
	    else
		strcat(abuf, "[], ");
	} else
	    strcat(abuf, ", ");
	do_start_arg(1);
	if (is_const)
	    strcat(abuf, "const ");
	sprintf(abuf + strlen(abuf), "%s)", atype2[0] ? atype2 : atype);
	strcat(abuf, ", ");
	do_start_arg(1);
	if (is_const)
	    strcat(abuf, "const ");
	if (is_ptr)
	    sprintf(abuf + strlen(abuf), "%s)", atype2[0] ? atype2 : atype);
	else
	    sprintf(abuf + strlen(abuf), "%s)", atype3[0] ?
		atype3 : (atype2[0] ? atype2 : atype));
	strcat(abuf, ", ");
	do_start_arg(2);
	break;
    }
    if (is_ptr) {
	real_arg_size = ptr_size;
	if (is_far)
	    real_arg_size *= 2;
    } else {
	if (arg_size <= 0) {
	    if (arg_size == 0 && arg_num)
		yyerror("parse error, void argument?");
	    if (arg_size == -1 && !last)
		yyerror("unknown argument size");
	    arg_num++;
	    return;
	}
	real_arg_size = al_arg_size;
    }
    assert(real_arg_size > 0);
    arg_offs += real_arg_size;
    arg_num++;
}

static void add_flg(char *buf, const char *flg, int num)
{
    if (!num) {
	strcpy(buf, flg);
    } else {
	strcat(buf, " | ");
	strcat(buf, flg);
    }
}

static const char *get_flags(void)
{
    static char buf[32];
    int flg = 0;

    if (is_ffar)
	add_flg(buf, "_TFLG_FAR", flg++);
    if (is_noret)
	add_flg(buf, "_TFLG_NORET", flg++);
    if (is_init)
	add_flg(buf, "_TFLG_INIT", flg++);
    if (!flg)
	add_flg(buf, "_TFLG_NONE", flg++);
    return buf;
}

#define AL(x) (((x) + (align - 1)) & ~(align - 1))
static const char *al_s_type(void) { return (align == 2 ? "WORD" : "DWORD"); }
static const char *al_u_type(void) { return (align == 2 ? "UWORD" : "UDWORD"); }
#define ATYPE3(s) \
    if (al_arg_size > arg_size) \
	strcat(atype3, al_##s##_type())


#line 388 "src/thunk_gen.p/thunk_gen.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "thunk_gen.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_LB = 3,                         /* LB  */
  YYSYMBOL_RB = 4,                         /* RB  */
  YYSYMBOL_SEMIC = 5,                      /* SEMIC  */
  YYSYMBOL_COMMA = 6,                      /* COMMA  */
  YYSYMBOL_ASTER = 7,                      /* ASTER  */
  YYSYMBOL_NEWLINE = 8,                    /* NEWLINE  */
  YYSYMBOL_STRING = 9,                     /* STRING  */
  YYSYMBOL_NUM = 10,                       /* NUM  */
  YYSYMBOL_ASMCFUNC = 11,                  /* ASMCFUNC  */
  YYSYMBOL_ASMPASCAL = 12,                 /* ASMPASCAL  */
  YYSYMBOL_FAR = 13,                       /* FAR  */
  YYSYMBOL_SEGM = 14,                      /* SEGM  */
  YYSYMBOL_INITTEXT = 15,                  /* INITTEXT  */
  YYSYMBOL_VOID = 16,                      /* VOID  */
  YYSYMBOL_WORD = 17,                      /* WORD  */
  YYSYMBOL_UWORD = 18,                     /* UWORD  */
  YYSYMBOL_CHAR = 19,                      /* CHAR  */
  YYSYMBOL_BYTE = 20,                      /* BYTE  */
  YYSYMBOL_UBYTE = 21,                     /* UBYTE  */
  YYSYMBOL_DWORD = 22,                     /* DWORD  */
  YYSYMBOL_UDWORD = 23,                    /* UDWORD  */
  YYSYMBOL_DOUBLE = 24,                    /* DOUBLE  */
  YYSYMBOL_LDOUBLE = 25,                   /* LDOUBLE  */
  YYSYMBOL_FLOAT = 26,                     /* FLOAT  */
  YYSYMBOL_QWORD = 27,                     /* QWORD  */
  YYSYMBOL_UQWORD = 28,                    /* UQWORD  */
  YYSYMBOL_STRUCT = 29,                    /* STRUCT  */
  YYSYMBOL_UNION = 30,                     /* UNION  */
  YYSYMBOL_LBR = 31,                       /* LBR  */
  YYSYMBOL_RBR = 32,                       /* RBR  */
  YYSYMBOL_CONST = 33,                     /* CONST  */
  YYSYMBOL_OUT = 34,                       /* OUT  */
  YYSYMBOL_NORETURN = 35,                  /* NORETURN  */
  YYSYMBOL_V_FW = 36,                      /* V_FW  */
  YYSYMBOL_V_BW = 37,                      /* V_BW  */
  YYSYMBOL_YYACCEPT = 38,                  /* $accept  */
  YYSYMBOL_input = 39,                     /* input  */
  YYSYMBOL_line = 40,                      /* line  */
  YYSYMBOL_lb = 41,                        /* lb  */
  YYSYMBOL_rb = 42,                        /* rb  */
  YYSYMBOL_lnum = 43,                      /* lnum  */
  YYSYMBOL_num = 44,                       /* num  */
  YYSYMBOL_fname = 45,                     /* fname  */
  YYSYMBOL_sname = 46,                     /* sname  */
  YYSYMBOL_tname = 47,                     /* tname  */
  YYSYMBOL_cname = 48,                     /* cname  */
  YYSYMBOL_rquals = 49,                    /* rquals  */
  YYSYMBOL_quals = 50,                     /* quals  */
  YYSYMBOL_arr = 51,                       /* arr  */
  YYSYMBOL_fatr = 52,                      /* fatr  */
  YYSYMBOL_fatrs = 53,                     /* fatrs  */
  YYSYMBOL_attr = 54,                      /* attr  */
  YYSYMBOL_attrs = 55,                     /* attrs  */
  YYSYMBOL_rq_fa = 56,                     /* rq_fa  */
  YYSYMBOL_rtype = 57,                     /* rtype  */
  YYSYMBOL_vref = 58,                      /* vref  */
  YYSYMBOL_atype = 59,                     /* atype  */
  YYSYMBOL_rdecls = 60,                    /* rdecls  */
  YYSYMBOL_adecls = 61,                    /* adecls  */
  YYSYMBOL_argsep = 62,                    /* argsep  */
  YYSYMBOL_args = 63,                      /* args  */
  YYSYMBOL_arg = 64                        /* arg  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   109

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  38
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  27
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  114

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   292


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   333,   333,   334,   337,   416,   418,   421,   423,   425,
     427,   429,   431,   434,   435,   438,   439,   440,   441,   444,
     445,   448,   449,   450,   451,   452,   453,   456,   457,   460,
     463,   464,   467,   468,   469,   470,   473,   477,   480,   483,
     486,   489,   492,   495,   498,   501,   504,   507,   510,   516,
     521,   529,   536,   543,   550,   556,   562,   567,   572,   577,
     582,   587,   592,   597,   603,   609,   615,   619,   623,   629,
     632,   633,   634,   637,   639,   640,   643,   644,   645
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "LB", "RB", "SEMIC",
  "COMMA", "ASTER", "NEWLINE", "STRING", "NUM", "ASMCFUNC", "ASMPASCAL",
  "FAR", "SEGM", "INITTEXT", "VOID", "WORD", "UWORD", "CHAR", "BYTE",
  "UBYTE", "DWORD", "UDWORD", "DOUBLE", "LDOUBLE", "FLOAT", "QWORD",
  "UQWORD", "STRUCT", "UNION", "LBR", "RBR", "CONST", "OUT", "NORETURN",
  "V_FW", "V_BW", "$accept", "input", "line", "lb", "rb", "lnum", "num",
  "fname", "sname", "tname", "cname", "rquals", "quals", "arr", "fatr",
  "fatrs", "attr", "attrs", "rq_fa", "rtype", "vref", "atype", "rdecls",
  "adecls", "argsep", "args", "arg", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-31)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -31,    50,   -31,   -31,     2,    -5,   -31,   -31,   -31,   -31,
     -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,
     -31,    -6,    17,   -31,   -31,   -31,    25,    48,   -31,   -31,
      43,    43,   -31,   -31,   -31,    63,   -31,    58,   -31,   -31,
     -31,   -31,    19,    64,   -31,    -3,   -31,   -31,   -31,   -31,
     -31,   -31,   -31,   -31,   -31,   -31,   -31,   -31,    60,    60,
      68,    68,   -31,    52,    61,    21,   -31,   -31,    65,    70,
      71,   -31,   -31,   -31,   -31,    52,    52,    52,    52,    -8,
     -31,   -31,    40,   -31,   -31,    41,    19,    66,    69,    72,
     -31,   -31,   -31,   -31,   -31,    49,   -31,   -31,    41,    75,
     -31,   -31,    95,    96,    97,   -31,   -31,   -31,    99,   -31,
     -31,    87,   100,   -31
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       3,     0,     1,     8,     0,     0,     7,     2,    36,    37,
      38,    47,    46,    48,    39,    40,    44,    45,    43,    41,
      42,    35,     0,    14,    21,    22,    25,     0,    23,    24,
      33,    28,    34,    69,     9,     0,    13,     0,    25,    32,
      27,     5,     0,     0,    11,    52,    54,    55,    53,    63,
      64,    56,    57,    61,    62,    60,    58,    59,     0,     0,
       0,     0,    68,    18,    78,     0,    75,    26,     0,     0,
       0,    51,    10,    66,    67,    18,    18,    18,    18,     0,
      70,    17,    77,     6,    73,    31,     0,     0,     0,     0,
      71,    72,    16,    15,    20,     0,    76,    29,    31,     0,
      74,    12,     0,     0,     0,    19,    30,     4,     0,    49,
      50,     0,     0,    65
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -31,   -31,   -31,   -31,   -31,   -31,    26,   -31,    47,   -31,
     -31,   -31,   -14,    27,   -31,   -27,   -31,     9,   -31,   -31,
     -31,   -30,   -31,   -31,   -31,   -31,    22
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     1,     4,    42,    85,     5,     6,    35,    73,    62,
     102,    30,    80,    81,    31,    32,    98,    99,    33,    21,
      71,    63,    22,    64,    86,    65,    66
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      68,    23,     3,    39,    40,    24,    25,    26,    27,    28,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    94,    83,    34,    84,    44,    29,
      75,    76,    36,    69,    70,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
       2,    37,    60,    61,    24,    25,    38,    27,    28,    77,
       3,    90,    91,    92,    93,    78,    41,    43,    67,    72,
      82,    79,    87,    88,    89,   101,    97,    44,    29,   103,
     107,   105,   104,    79,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,   108,
     109,   110,   111,   112,   113,    95,    74,   106,   100,    96
};

static const yytype_int8 yycheck[] =
{
       3,     7,    10,    30,    31,    11,    12,    13,    14,    15,
       8,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    32,     4,     9,     6,     9,    35,
      60,    61,     7,    36,    37,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       0,     3,    33,    34,    11,    12,    13,    14,    15,     7,
      10,    75,    76,    77,    78,    13,     3,     9,     4,     9,
       9,    31,     7,     3,     3,     9,    35,     9,    35,    10,
       5,    32,    10,    31,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,     4,
       4,     4,     3,    16,     4,    79,    59,    98,    86,    82
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    39,     0,    10,    40,    43,    44,     8,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    57,    60,     7,    11,    12,    13,    14,    15,    35,
      49,    52,    53,    56,     9,    45,     7,     3,    13,    53,
      53,     3,    41,     9,     9,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      33,    34,    47,    59,    61,    63,    64,     4,     3,    36,
      37,    58,     9,    46,    46,    59,    59,     7,    13,    31,
      50,    51,     9,     4,     6,    42,    62,     7,     3,     3,
      50,    50,    50,    50,    32,    44,    51,    35,    54,    55,
      64,     9,    48,    10,    10,    32,    55,     5,     4,     4,
       4,     3,    16,     4
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    38,    39,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    49,    50,    50,    50,    50,    51,
      51,    52,    52,    52,    52,    52,    52,    53,    53,    54,
      55,    55,    56,    56,    56,    56,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    58,
      58,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    60,
      61,    61,    61,    62,    63,    63,    64,    64,    64
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     0,     8,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     2,     1,     0,     3,
       2,     1,     1,     1,     1,     1,     4,     2,     1,     1,
       2,     0,     2,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     8,     2,     2,     1,     2,
       2,     3,     3,     1,     3,     1,     3,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* line: lnum rdecls fname lb args rb attrs SEMIC  */
#line 338 "../src/thunk_gen.y"
                        {
			  const char *rt, *rv;

			  if (is_rptr) {
			    rt = "_RET_PTR";
			    rv = "_ARG_RPTR";
			    rlen = ptr_size;
			    if (is_rfar) {
			      rlen *= 2;
			      rt = "_RET_PTR_FAR";
			      rv = "_ARG_RPTR_FAR";
			    }
			  } else {
			    rt = "_RET";
			    rv = "_ARG_R";
			  }
			  switch (thunk_type) {
			  case 0:
			    if (!is_rvoid) {
			      if (abuf[0])
			        printf("\tcase %i:\n\t\t_DISPATCH(%i, %s(%s), %s, %s, %s);\n\t\tbreak;\n",
				    (yyvsp[-7].lnum), rlen, rv, rtbuf, rt, (yyvsp[-5].fname), abuf);
			      else
			        printf("\tcase %i:\n\t\t_DISPATCH(%i, %s(%s), %s, %s);\n\t\tbreak;\n",
				    (yyvsp[-7].lnum), rlen, rv, rtbuf, rt, (yyvsp[-5].fname));
			    } else {
			      if (abuf[0])
			        printf("\tcase %i:\n\t\t_DISPATCH_v(%s, %s);\n\t\tbreak;\n",
				    (yyvsp[-7].lnum), (yyvsp[-5].fname), abuf);
			      else
			        printf("\tcase %i:\n\t\t_DISPATCH_v(%s);\n\t\tbreak;\n",
				    (yyvsp[-7].lnum), (yyvsp[-5].fname));
			    }
			    break;
			  case 1: {
			    int is_v = is_rvoid && !is_rptr;
			    if (!is_v && is_noret)
			      yyerror("non-void noret?");
			    else if (is_noret)
			      is_v++;
			    /* for m4 */
			    printf("THUNK(%i, %i, %i, %s%s%s)\n",
			        arg_num, is_v, is_pas,
			        is_pas ? "_P" : "",
			        is_v ? "_v" : "",
			        is_noret ? "_nr" : ""
			        );
			    break;
			  }
			  case 2:
			    /* for cpp */
			    if (!is_rvoid || is_rptr)
			      printf("_THUNK%i%s(%i, %s(%s), %s, %s",
			          arg_num,
			          is_pas ? "_P" : "",
			          (yyvsp[-7].lnum),
			          is_rptr ? (is_rfar ? "__ARG_PTR_FAR" :
			                  "__ARG_PTR") : "__ARG",
			          rtbuf,
			          is_rptr ? (is_rfar ? "__RET_PTR_FAR" :
			                  "__RET_PTR") : "__RET",
			          (yyvsp[-5].fname));
			    else
			      printf("_THUNK%i%s_v%s(%i, %svoid, %s",
			          arg_num,
			          is_pas ? "_P" : "",
			          is_noret ? "_nr" : "",
			          (yyvsp[-7].lnum),
			          is_noret ? "__NORET " : "",
			          (yyvsp[-5].fname));
			    if (arg_num)
			      printf(", %s", abuf);
			    printf(", %s)\n", get_flags());
			    break;
			  }
			}
#line 1589 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 5: /* lb: LB  */
#line 416 "../src/thunk_gen.y"
                        { arg_offs = 0; arg_num = 0; beg_arg(); }
#line 1595 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 6: /* rb: RB  */
#line 418 "../src/thunk_gen.y"
                        { fin_arg(1); }
#line 1601 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 7: /* lnum: num  */
#line 421 "../src/thunk_gen.y"
                        { init_line(); }
#line 1607 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 13: /* rquals: FAR ASTER  */
#line 434 "../src/thunk_gen.y"
                                { is_rfar = 1; is_rptr = 1; }
#line 1613 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 14: /* rquals: ASTER  */
#line 435 "../src/thunk_gen.y"
                                { is_rptr = 1; }
#line 1619 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 15: /* quals: FAR quals  */
#line 438 "../src/thunk_gen.y"
                                { is_far = 1; }
#line 1625 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 16: /* quals: ASTER quals  */
#line 439 "../src/thunk_gen.y"
                                { is_ptr = 1; }
#line 1631 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 19: /* arr: LBR num RBR  */
#line 444 "../src/thunk_gen.y"
                                { cvtype == CVTYPE_CHAR ? cvtype = CVTYPE_CHAR_ARR : CVTYPE_ARR; is_arr = 1; arr_sz = (yyvsp[-1].num); }
#line 1637 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 20: /* arr: LBR RBR  */
#line 445 "../src/thunk_gen.y"
                                { cvtype == CVTYPE_CHAR ? cvtype = CVTYPE_CHAR_ARR : CVTYPE_ARR; is_arr = 1; arr_sz = -1; }
#line 1643 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 22: /* fatr: ASMPASCAL  */
#line 449 "../src/thunk_gen.y"
                                { is_pas = 1; }
#line 1649 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 23: /* fatr: INITTEXT  */
#line 450 "../src/thunk_gen.y"
                                { is_init = 1; }
#line 1655 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 24: /* fatr: NORETURN  */
#line 451 "../src/thunk_gen.y"
                                { is_noret = 1; }
#line 1661 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 25: /* fatr: FAR  */
#line 452 "../src/thunk_gen.y"
                                { is_ffar = 1; }
#line 1667 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 29: /* attr: NORETURN  */
#line 460 "../src/thunk_gen.y"
                                { is_noret = 1; }
#line 1673 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 36: /* rtype: VOID  */
#line 473 "../src/thunk_gen.y"
                                { rlen = 0;
				  strcpy(rtbuf, "void");
				  is_rvoid = 1;
				}
#line 1682 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 37: /* rtype: WORD  */
#line 477 "../src/thunk_gen.y"
                                { rlen = 2;
				  strcpy(rtbuf, "WORD");
				}
#line 1690 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 38: /* rtype: UWORD  */
#line 480 "../src/thunk_gen.y"
                                { rlen = 2;
				  strcpy(rtbuf, "UWORD");
				}
#line 1698 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 39: /* rtype: DWORD  */
#line 483 "../src/thunk_gen.y"
                                { rlen = 4;
				  strcpy(rtbuf, "DWORD");
				}
#line 1706 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 40: /* rtype: UDWORD  */
#line 486 "../src/thunk_gen.y"
                                { rlen = 4;
				  strcpy(rtbuf, "UDWORD");
				}
#line 1714 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 41: /* rtype: QWORD  */
#line 489 "../src/thunk_gen.y"
                                { rlen = 8;
				  strcpy(rtbuf, "QWORD");
				}
#line 1722 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 42: /* rtype: UQWORD  */
#line 492 "../src/thunk_gen.y"
                                { rlen = 8;
				  strcpy(rtbuf, "UQWORD");
				}
#line 1730 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 43: /* rtype: FLOAT  */
#line 495 "../src/thunk_gen.y"
                                { rlen = 4;
				  strcpy(rtbuf, "float");
				}
#line 1738 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 44: /* rtype: DOUBLE  */
#line 498 "../src/thunk_gen.y"
                                { rlen = 8;
				  strcpy(rtbuf, "double");
				}
#line 1746 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 45: /* rtype: LDOUBLE  */
#line 501 "../src/thunk_gen.y"
                                { rlen = 12;
				  strcpy(rtbuf, "long double");
				}
#line 1754 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 46: /* rtype: BYTE  */
#line 504 "../src/thunk_gen.y"
                                { rlen = 1;
				  strcpy(rtbuf, "BYTE");
				}
#line 1762 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 47: /* rtype: CHAR  */
#line 507 "../src/thunk_gen.y"
                                { rlen = 1;
				  strcpy(rtbuf, "char");
				}
#line 1770 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 48: /* rtype: UBYTE  */
#line 510 "../src/thunk_gen.y"
                                { rlen = 1;
				  strcpy(rtbuf, "UBYTE");
				}
#line 1778 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 49: /* vref: V_FW LB NUM RB  */
#line 517 "../src/thunk_gen.y"
                                {
				  ref_inc = 1;
				  ref_mult = (yyvsp[-1].NUM);
				}
#line 1787 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 50: /* vref: V_BW LB NUM RB  */
#line 522 "../src/thunk_gen.y"
                                {
				  ref_inc = -1;
				  ref_mult = (yyvsp[-1].NUM);
				}
#line 1796 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 51: /* atype: VOID vref  */
#line 529 "../src/thunk_gen.y"
                                {
				  arg_size = 0;
				  cvtype = CVTYPE_VOID;
				  strcat(atype, "VOID");
				  al_arg_size = AL(arg_size);
				  is_void = 1;
				}
#line 1808 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 52: /* atype: VOID  */
#line 536 "../src/thunk_gen.y"
                                {
				  arg_size = 0;
				  cvtype = CVTYPE_VOID;
				  strcat(atype, "VOID");
				  al_arg_size = AL(arg_size);
				  is_void = 1;
				}
#line 1820 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 53: /* atype: CHAR  */
#line 543 "../src/thunk_gen.y"
                                {
				  arg_size = 1;
				  cvtype = CVTYPE_CHAR;
				  strcat(atype, "char");
				  al_arg_size = AL(arg_size);
				  ATYPE3(s);
				}
#line 1832 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 54: /* atype: WORD  */
#line 550 "../src/thunk_gen.y"
                                {
				  arg_size = 2;
				  strcat(atype, "WORD");
				  al_arg_size = AL(arg_size);
				  ATYPE3(s);
				}
#line 1843 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 55: /* atype: UWORD  */
#line 556 "../src/thunk_gen.y"
                                {
				  arg_size = 2;
				  strcat(atype, "UWORD");
				  al_arg_size = AL(arg_size);
				  ATYPE3(u);
				}
#line 1854 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 56: /* atype: DWORD  */
#line 562 "../src/thunk_gen.y"
                                {
				  arg_size = 4;
				  strcat(atype, "DWORD");
				  al_arg_size = AL(arg_size);
				}
#line 1864 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 57: /* atype: UDWORD  */
#line 567 "../src/thunk_gen.y"
                                {
				  arg_size = 4;
				  strcat(atype, "UDWORD");
				  al_arg_size = AL(arg_size);
				}
#line 1874 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 58: /* atype: QWORD  */
#line 572 "../src/thunk_gen.y"
                                {
				  arg_size = 8;
				  strcat(atype, "QWORD");
				  al_arg_size = AL(arg_size);
				}
#line 1884 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 59: /* atype: UQWORD  */
#line 577 "../src/thunk_gen.y"
                                {
				  arg_size = 8;
				  strcat(atype, "UQWORD");
				  al_arg_size = AL(arg_size);
				}
#line 1894 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 60: /* atype: FLOAT  */
#line 582 "../src/thunk_gen.y"
                        {
				  arg_size = 4;
				  strcat(atype, "float");
				  al_arg_size = AL(arg_size);
				}
#line 1904 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 61: /* atype: DOUBLE  */
#line 587 "../src/thunk_gen.y"
                                {
				  arg_size = 8;
				  strcat(atype, "double");
				  al_arg_size = AL(arg_size);
				}
#line 1914 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 62: /* atype: LDOUBLE  */
#line 592 "../src/thunk_gen.y"
                                {
				  arg_size = 12;
				  strcat(atype, "long double");
				  al_arg_size = AL(arg_size);
				}
#line 1924 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 63: /* atype: BYTE  */
#line 597 "../src/thunk_gen.y"
                                {
				  arg_size = 1;
				  strcat(atype, "BYTE");
				  al_arg_size = AL(arg_size);
				  ATYPE3(s);
				}
#line 1935 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 64: /* atype: UBYTE  */
#line 603 "../src/thunk_gen.y"
                                {
				  arg_size = 1;
				  strcat(atype, "UBYTE");
				  al_arg_size = AL(arg_size);
				  ATYPE3(u);
				}
#line 1946 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 65: /* atype: VOID LB ASTER cname RB LB VOID RB  */
#line 609 "../src/thunk_gen.y"
                                                    {
				  arg_size = 4;
				  is_cbk = 1;
				  strcat(atype, "VOID");
				  al_arg_size = AL(arg_size);
				}
#line 1957 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 66: /* atype: STRUCT sname  */
#line 615 "../src/thunk_gen.y"
                                {
				  arg_size = -1;
				  sprintf(atype + strlen(atype), "struct %s", (yyvsp[0].sname));
				}
#line 1966 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 67: /* atype: UNION sname  */
#line 619 "../src/thunk_gen.y"
                                {
				  arg_size = -1;
				  sprintf(atype + strlen(atype), "union %s", (yyvsp[0].sname));
				}
#line 1975 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 68: /* atype: tname  */
#line 623 "../src/thunk_gen.y"
                                {
				  arg_size = -1;
				  sprintf(atype + strlen(atype), "%s", (yyvsp[0].tname));
				}
#line 1984 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 69: /* rdecls: rtype rq_fa  */
#line 629 "../src/thunk_gen.y"
                                { abuf[0] = 0; }
#line 1990 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 71: /* adecls: CONST atype quals  */
#line 633 "../src/thunk_gen.y"
                                        { is_const = 1; }
#line 1996 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 72: /* adecls: OUT atype quals  */
#line 634 "../src/thunk_gen.y"
                                        { is_out = 1; }
#line 2002 "src/thunk_gen.p/thunk_gen.tab.c"
    break;

  case 73: /* argsep: COMMA  */
#line 637 "../src/thunk_gen.y"
                                { fin_arg(0); strcat(abuf, ", "); beg_arg(); }
#line 2008 "src/thunk_gen.p/thunk_gen.tab.c"
    break;


#line 2012 "src/thunk_gen.p/thunk_gen.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 648 "../src/thunk_gen.y"


int main(int argc, char *argv[])
{
    const char *optstr = "dp:a:";
    int c;
    yydebug = 0;

    while ((c = getopt(argc, argv, optstr)) != -1) {
	switch (c) {
	    case 'a':
		align = atoi(optarg);
		break;
	    case 'p':
		ptr_size = atoi(optarg);
		break;
	    case 'd':
		yydebug = 1;
		break;
	    case '?':
		fprintf(stderr, "unknown option %c\n", c);
		return EXIT_FAILURE;
	}
    }
    if (optind < argc)
	thunk_type = atoi(argv[optind++]);

    if (thunk_type == 1)
	printf(
		"/* generated with thunk-gen v%s */"
		"nl()"
		"sp_num(define TG_ABI %i)"
		"sp_num(ifndef __CALL_v)"
		"sp_num(define __CALL_v __CALL)"
		"sp_num(endif)"
		"sp_num(ifndef __CALL_v_nr)"
		"sp_num(define __CALL_v_nr __CALL)"
		"sp_num(endif)"
		"sp_num(ifndef __CALL_P)"
		"sp_num(define __CALL_P __CALL)"
		"sp_num(endif)"
		"sp_num(ifndef __CALL_P_v)"
		"sp_num(define __CALL_P_v __CALL)"
		"sp_num(endif)"
		"sp_num(ifndef __NORET)"
		"sp_num(define __NORET)"
		"sp_num(endif)"
		"\n", VERSION, tg_abi);
    yyparse();
    return 0;
}

static void yyerror(const char* s)
{
    fprintf(stderr, "Parse error: %s\n", s);
    exit(1);
}
